Index: codes/icosagcm/trunk/param_sets/make_rundefs.sh
===================================================================
--- codes/icosagcm/trunk/param_sets/make_rundefs.sh	(revision 216)
+++ codes/icosagcm/trunk/param_sets/make_rundefs.sh	(revision 217)
@@ -55,5 +55,5 @@
 function itau_adv { print 'Advection called every itau_adv time steps' integer 2 itau_adv $1 
 }
-function nqtot { print 'Number of tracers' integer 1 nqtot $1 
+function nqtot { print 'Number of tracers' integer 1 nqtot $1
 }
 function caldyn { print 'Equations solved' '[gcm|adv]' gcm caldyn $1 
@@ -84,5 +84,5 @@
 function etat0 { 
     OPTS=$(printf '\n#   [jablonowsky06|academic|dcmip[1-4]|heldsz|dcmip2_schaer_noshear|dcmip3]')
-    print 'Initial state' "$OPTS" jablonowsky06 etat0 $1 
+    print 'Initial state' "$OPTS" jablonowsky06 etat0 $1
 }
 function dissip
@@ -98,5 +98,5 @@
 }
 
-function physics { print 'Physics package' '[automatic|dcmip]' automatic physics $1
+function physics { print 'Physics package' '[none|held_suarez|dcmip]' none physics $1
 }
 
@@ -160,5 +160,5 @@
     group 'Time' time_style lmd ndays 1200 write_period 86400
     group 'Planet' radius 6.371e6 g 9.8 omega 7.292e-5 kappa 0.2857143 cpp 1004 preff 1e5
-    group 'Physical parameters' etat0 held_suarez nqtot 1
+    group 'Physical parameters' etat0 held_suarez physics held_suarez
     dissip 50000 2 50000 2 50000 2
 }
@@ -186,5 +186,5 @@
     dissip 1800 1 1800 2 1800 2
     group 'Time' run_length 3.6e6 write_period 50000
-    group 'Physical parameters' scale_factor 500 guided_type dcmip1 nqtot 1 etat0 dcmip2_schaer_noshear
+    group 'Physical parameters' scale_factor 500 guided_type dcmip1 etat0 dcmip2_schaer_noshear
 }
 
@@ -196,5 +196,5 @@
     dissip 1800 1 1800 2 1800 2
     group 'Time' run_length 4.5e5 write_period 12500
-    group 'Physical parameters' omega 0 scale_factor 125 nqtot 1 etat0 dcmip3
+    group 'Physical parameters' omega 0 scale_factor 125 etat0 dcmip3
 }
 
Index: codes/icosagcm/trunk/src/physics.f90
===================================================================
--- codes/icosagcm/trunk/src/physics.f90	(revision 216)
+++ codes/icosagcm/trunk/src/physics.f90	(revision 217)
@@ -11,5 +11,5 @@
   TYPE(t_field),POINTER :: f_dulon(:), f_dulat(:)
 
-  CHARACTER(LEN=255) :: physics_type="automatic"
+  CHARACTER(LEN=255) :: physics_type
 !$OMP THREADPRIVATE(physics_type)
 
@@ -26,35 +26,27 @@
     IMPLICIT NONE
 
-    CALL allocate_field(f_dulon,field_t,type_real,llm, name='dulon')
-    CALL allocate_field(f_dulat,field_t,type_real,llm, name='dulat')
-    CALL init_pack_before ! Compute physics_inout%ngrid and offsets used by pack/unpack
-    
-    physics_type='automatic'
+    physics_inout%dt_phys = dt*itau_physics
+    physics_type='none'
     CALL getin("physics",physics_type)
-
     SELECT CASE(TRIM(physics_type))
-    CASE ('automatic')
-       etat0_type='jablonowsky06'
-       CALL getin("etat0",etat0_type)
-       SELECT CASE(TRIM(etat0_type))
-       CASE('held_suarez')
-          phys_type = phys_HS94
-       CASE DEFAULT
-          IF(is_mpi_root) PRINT*,"NO PHYSICAL PACKAGE USED"
-          phys_type = phys_none
-       END SELECT
-
+    CASE ('none')
+       IF(is_mpi_root) PRINT*,"NO PHYSICAL PACKAGE USED"
+       phys_type = phys_none
+    CASE ('held_suarez')
+       phys_type = phys_HS94
     CASE ('dcmip')
+       CALL allocate_field(f_dulon,field_t,type_real,llm, name='dulon')
+       CALL allocate_field(f_dulat,field_t,type_real,llm, name='dulat')
+       CALL init_pack_before ! Compute physics_inout%ngrid and offsets used by pack/unpack
        CALL init_physics_dcmip
+       CALL init_pack_after ! Defines Ai, lon, lat in physics_inout
        phys_type = phys_DCMIP
     CASE DEFAULT
        IF(is_mpi_root) PRINT*, 'init_physics : Bad selector for variable physics <',&
-            TRIM(physics_type), '> options are <automatic>, <dcmip>, <dry>'
+            TRIM(physics_type), '> options are <none>, <held_suarez>, <dcmip>'
        STOP
     END SELECT
 
     IF(is_mpi_root) PRINT *, 'phys_type = ',phys_type
-    physics_inout%dt_phys = dt*itau_physics
-    CALL init_pack_after ! Defines Ai, lon, lat in physics_inout
   END SUBROUTINE init_physics
 