Index: codes/icosagcm/branches/SATURN_DYNAMICO/TEST/icosa.xml
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/TEST/icosa.xml	(revision 256)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/TEST/icosa.xml	(revision 256)
@@ -0,0 +1,48 @@
+ <context id="icosagcm" calendar_type="Gregorian" start_date="2012-03-01 15:00:00" time_origin="2012-02-29 15:00:00">
+    
+
+   <field_definition level="1" enabled=".TRUE." operation="instant">
+     
+     <field_group domain_ref="i">
+       <field id="ps" />
+       <field id="dps"  />
+       
+       <field_group axis_ref="lev"> 
+         <field id="mass" />
+         <field id="dmass"/>
+         <field id="theta" />
+         <field id="exner"/>
+         <field id="q1"/>
+         <field id="q2"/>
+       </field_group>
+     </field_group> 
+     
+     <field_group domain_ref="v" axis_ref="lev">
+       <field id="vort" />
+       <field id="pv" />
+     </field_group>
+     
+   </field_definition>
+    
+    
+   <file_definition type="one_file" par_access="collective" output_freq="2h" sync_freq="2h" output_level="10" enabled=".TRUE.">
+     <file id="output" name="output" > 
+       <field_group group_ref="field_definition"/>
+     </file>
+   </file_definition>
+    
+    
+   <axis_definition>
+     <axis id="lev" zoom_begin="1" zoom_size="1" />
+     <axis id="levp1"  />
+   </axis_definition>
+    
+   <domain_definition>
+     <domain id="i" />
+     <domain id="v" />
+   </domain_definition>    
+
+
+   <grid_definition />    
+  
+ </context>
Index: codes/icosagcm/branches/SATURN_DYNAMICO/TEST/iodef.xml
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/TEST/iodef.xml	(revision 256)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/TEST/iodef.xml	(revision 256)
@@ -0,0 +1,22 @@
+<?xml version="1.0"?>
+<simulation> 
+
+  <context id="icosagcm" src="./icosa.xml" /> 
+  <context id="lmdz_physics" src="./lmdz_physics.xml" /> 
+
+  <context id="xios">
+      <variable_definition>
+        <variable_group id="buffer">
+            buffer_size = 800000000
+            buffer_server_factor_size = 2 
+         </variable_group>
+
+        <variable_group id="parameters" >
+          <variable id="using_server" type="boolean">false</variable>
+          <variable id="info_level" type="int">0</variable>
+        </variable_group>
+      </variable_definition>
+  </context>
+
+</simulation>
+
Index: codes/icosagcm/branches/SATURN_DYNAMICO/TEST/job_curie
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/TEST/job_curie	(revision 255)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/TEST/job_curie	(revision 256)
@@ -6,6 +6,6 @@
 #MSUB -o dynamico.out   # nom du fichier de sortie
 #MSUB -e dynamico.err
-#MSUB -n 1       # reservation des processeurs pour le job
-#MSUB -c 1           
+#MSUB -n 10       # reservation des processeurs pour le job
+#MSUB -c 4           
 #MSUB -x             # exclusif
 #MSUB -T 1800           # Limite temps (en secondes)
@@ -35,8 +35,8 @@
 export VT_MAX_STACK_DEPTH=10000
 export FOR_DEBUGGER_IS_PRESENT=True
-export OMP_NUM_THREADS=1
+export OMP_NUM_THREADS=4
 export OMP_WAIT_POLICY=ACTIVE
 #export OMPI_MCA_mpi_leave_pinned=1
-export OMP_STACKSIZE=10M
+export OMP_STACKSIZE=100M
 
 #ccc_mprun -d tv $EXEC_NAME
Index: codes/icosagcm/branches/SATURN_DYNAMICO/TEST/lmdz_physics.xml
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/TEST/lmdz_physics.xml	(revision 256)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/TEST/lmdz_physics.xml	(revision 256)
@@ -0,0 +1,47 @@
+ <context id="lmdz_physics" calendar_type="D360" start_date="2014-01-01 00:00:00" time_origin="2014-01-01 00:00:00">
+    
+
+   <field_definition level="1" enabled=".TRUE." operation="instant" domain_ref="horiz_domain">
+     
+     <field id="phisinit" long_name="Geopotential at the surface" operation="once"/>
+     <field id="aire"     long_name="Mesh area" operation="once"/>
+ 
+     <field id="tsurf"  long_name="Surface temperature"         unit="K"/>
+     <field id="ps"     long_name="Surface pressure"            unit="Pa"/>
+     <field id="ISR"    long_name="incoming stellar rad."       unit="W m-2"/>
+     <field id="ASR"    long_name="absorbed stellar rad."       unit="W m-2"/>
+     <field id="OLR"    long_name="outgoing longwave rad."      unit="W m-2"/>
+     
+     <field_group axis_ref="altitude">
+       <field id="temp" long_name="temperature"                 unit="K"/>
+       <field id="u"    long_name="Zonal wind"                  unit="m.s-1"/>
+       <field id="v"    long_name="Meridional wind"             unit="m.s-1"/>
+       <field id="p"    long_name="Pressure"                    unit="Pa"/>
+     </field_group> 
+     
+   </field_definition>
+    
+    
+   <file_definition type="one_file" par_access="collective" output_freq="10ts" sync_freq="10ts" output_level="10" enabled=".TRUE.">
+
+     <file id="xios_diagfi" name="xios_diagfi" > 
+ 
+        <field_group group_ref="field_definition" />
+       
+     </file>
+
+   </file_definition>
+    
+    
+   <axis_definition>
+     <axis id="altitude"/>
+   </axis_definition>
+    
+   <domain_definition>
+     <domain id="horiz_domain" />
+   </domain_definition>    
+
+
+   <grid_definition />    
+  
+ </context>
Index: codes/icosagcm/branches/SATURN_DYNAMICO/TEST/run_icosa.def
===================================================================
--- codes/icosagcm/branches/SATURN_DYNAMICO/TEST/run_icosa.def	(revision 255)
+++ codes/icosagcm/branches/SATURN_DYNAMICO/TEST/run_icosa.def	(revision 256)
@@ -55,8 +55,9 @@
 #run_length=0
 #run_length=432000
-run_length=864000
+# one saturn year
+run_length=929610360
 
 #activate IO (default = true)
-enable_io = true
+enable_io = false
 
 # output with XIOS (only if compiled with XIOS): true/false (default true)